# I3DEditorHostPanePart Struct Reference
[Shell Interfaces]

Inheritance diagram for I3DEditorHostPanePart:

List of all members.

## Public Member Functions
virtual I3DShCamera *MCCOMAPI | GetCurrentCameraNoAddRef () const =0
virtual void MCCOMAPI | SetCurrentCamera (I3DShCamera *camera, boolean resetPanAndZoom)=0
virtual void MCCOMAPI | GetInteractiveRenderer (I3DExRendererBox **renderer)=0
virtual void MCCOMAPI | GetPaneExtension (IEx3DEditorHostPanePart **paneExtension)=0
virtual void MCCOMAPI | SetPaneText (const TMCString &text)=0
virtual void MCCOMAPI | SetPaneIcon (uint32 inResourceID)=0
virtual void MCCOMAPI | ActivatePane ()=0
virtual void MCCOMAPI | DeactivatePane ()=0
virtual void MCCOMAPI | LocalToRenderSpace (const TMCPoint &local, TVector2 &render)=0
virtual void MCCOMAPI | RenderToLocalSpace (const TVector2 &render, TMCPoint &local)=0
virtual void MCCOMAPI | PixelRay (const TMCPoint &pixelPos, TVector3 &worldOrigin, TVector3 &worldDirection)=0
virtual void MCCOMAPI | RenderDraw (IMCGraphicContext *inContext, TMCRect *inZone, ISceneDocument *associatedSceneDoc)=0
virtual void MCCOMAPI | InvalidateRender ()=0
virtual boolean MCCOMAPI | NeedsReRender ()=0
virtual boolean MCCOMAPI | GetIsActive ()=0
virtual void MCCOMAPI | SetPopupCurrentItem (int16 index)=0
virtual int16 MCCOMAPI | GetPopupCurrentItem ()=0
virtual void MCCOMAPI | DrawTopLeftPopup (IMCGraphicContext *inContext, TMCRect *inZone)=0
virtual void MCCOMAPI | ZoomToCenter (double zoom)=0
virtual void MCCOMAPI | ZoomToRect (const TMCRealRect &rect)=0
virtual void MCCOMAPI | ZoomTo (const TMCRect &localRect)=0
virtual void MCCOMAPI | ZoomTo (const TMCPoint &localPos, boolean zoomIn)=0
virtual void MCCOMAPI | DoAreaRender (const TMCRect &rect, I3DRenderingCallbacks *callbacks=NULL)=0
virtual void MCCOMAPI | DoFinalBlit (boolean IsBlit)=0
virtual double MCCOMAPI | GetZoom ()=0
virtual void MCCOMAPI | SetZoom (double zoom)=0
virtual TVector2 MCCOMAPI | GetPan ()=0
virtual void MCCOMAPI | SetPan (TVector2 pan)=0
virtual void MCCOMAPI | GetTreeScreenBounds (I3DShTreeElement *tree, TMCRect &screenBounds)=0
virtual void MCCOMAPI | SetImmediateMode (boolean on)=0
virtual boolean MCCOMAPI | GetImmediateMode ()=0
virtual void MCCOMAPI | DeleteRenderingCaches ()=0
virtual I3DEditorHostPart *MCCOMAPI | Get3DEditorHost ()=0
virtual void MCCOMAPI | CreateRay (const TMCPoint &localPoint, Ray3D &outRay) const =0
virtual void MCCOMAPI | CreateRayFromPaneCenter (Ray3D &outRay) const =0
| Creates a ray by the current camera through the center of the part.
virtual void MCCOMAPI | GetTreeProjectionTransform (IRenderableData *inRenderableData, const int32 projIndex, TTreeProjectionTransform &outTransform) const =0
| Creates a TreeProjectionTransform using the given renderableData.
virtual const TTransform3D *MCCOMAPI | GetCurrentCameraTransform () const =0
| Returns the transform of the current camera.
virtual const TTransform3D *MCCOMAPI | GetCurrentCameraInverseTransform () const =0
virtual void MCCOMAPI | ViewBox (const TBBox3D &bbox)=0

## Detailed Description

This is the interface for the panes of the 3D Editor Host. You can derive a part extension from IEx3DEditorHostPanePart if you want to implement a pane for a 3DEditorHostPart. See I3DEditorHostPart for more info.

## Member Function Documentation

virtual void MCCOMAPI I3DEditorHostPanePart::ActivatePane | ( |  | ) | `[pure virtual]`

Called when the pane becomes active.

virtual void MCCOMAPI I3DEditorHostPanePart::CreateRay | ( | const TMCPoint & | localPoint,
|  | Ray3D & | outRay |
| ) |  |  | const`[pure virtual]`

virtual void MCCOMAPI I3DEditorHostPanePart::CreateRayFromPaneCenter | ( | Ray3D & | outRay | ) | const`[pure virtual]`

Creates a ray by the current camera through the center of the part.

virtual void MCCOMAPI I3DEditorHostPanePart::DeactivatePane | ( |  | ) | `[pure virtual]`

Calls when the pane is not active any longer.

virtual void MCCOMAPI I3DEditorHostPanePart::DeleteRenderingCaches | ( |  | ) | `[pure virtual]`

Delete all rendering caches

virtual void MCCOMAPI I3DEditorHostPanePart::DoAreaRender | ( | const TMCRect & | rect,
|  | I3DRenderingCallbacks * | callbacks = `NULL` |
| ) |  |  | `[pure virtual]`

Performs an area render in the pane part

Parameters:

  | rect | The rectangle in local coordinates of the pane (pixels)
  | callbacks | The function called when each tile is done. If null, standard callbacks are used.

virtual void MCCOMAPI I3DEditorHostPanePart::DoFinalBlit | ( | boolean | IsBlit | ) | `[pure virtual]`

Perform the final blit of the rendering.

Parameters:

  | IsBlit |

virtual void MCCOMAPI I3DEditorHostPanePart::DrawTopLeftPopup | ( | IMCGraphicContext * | inContext,
|  | TMCRect * | inZone |
| ) |  |  | `[pure virtual]`

Draws the popup menu at the top left of the pane.

Parameters:

  | inContext | The graphic context
  | inZone | The rectangle of the pane.

virtual I3DEditorHostPart* MCCOMAPI I3DEditorHostPanePart::Get3DEditorHost | ( |  | ) | `[pure virtual]`

Returns the 3DEditorHost that contains this part (and the other pane parts of the window)

virtual const TTransform3D* MCCOMAPI I3DEditorHostPanePart::GetCurrentCameraInverseTransform | ( |  | ) | const`[pure virtual]`

virtual I3DShCamera* MCCOMAPI I3DEditorHostPanePart::GetCurrentCameraNoAddRef | ( |  | ) | const`[pure virtual]`

Returns the current camera used for this view (pane).

virtual const TTransform3D* MCCOMAPI I3DEditorHostPanePart::GetCurrentCameraTransform | ( |  | ) | const`[pure virtual]`

Returns the transform of the current camera.

virtual boolean MCCOMAPI I3DEditorHostPanePart::GetImmediateMode | ( |  | ) | `[pure virtual]`

Return the current state of the immediate mode

virtual void MCCOMAPI I3DEditorHostPanePart::GetInteractiveRenderer | ( | I3DExRendererBox ** | renderer | ) | `[pure virtual]`

Returns a pointer to the interactive renderer of this pane.

Parameters:

  | renderer | A pointer to the interactive renderer.

virtual boolean MCCOMAPI I3DEditorHostPanePart::GetIsActive | ( |  | ) | `[pure virtual]`

Returns true if the pane is the active pane.

virtual TVector2 MCCOMAPI I3DEditorHostPanePart::GetPan | ( |  | ) | `[pure virtual]`

Returns the current pan (2D translation) of the pane.

virtual void MCCOMAPI I3DEditorHostPanePart::GetPaneExtension | ( | IEx3DEditorHostPanePart ** | paneExtension | ) | `[pure virtual]`

Returns a pointer to the external pane interface.

Parameters:

  | paneExtension | A pointer the pane interface.

virtual int16 MCCOMAPI I3DEditorHostPanePart::GetPopupCurrentItem | ( |  | ) | `[pure virtual]`

Returns the current item of the Pop up menu

virtual void MCCOMAPI I3DEditorHostPanePart::GetTreeProjectionTransform | ( | IRenderableData * | inRenderableData,
|  | const int32 | projIndex,
|  | TTreeProjectionTransform & | outTransform |
| ) |  |  | const`[pure virtual]`

Creates a TreeProjectionTransform using the given renderableData.

virtual void MCCOMAPI I3DEditorHostPanePart::GetTreeScreenBounds | ( | I3DShTreeElement * | tree,
|  | TMCRect & | screenBounds |
| ) |  |  | `[pure virtual]`

Returns a rectangle in pixels that contains the tree element.

Parameters:

  | tree | A tree element.
  | screenBounds | The bounding box on the screen.

virtual double MCCOMAPI I3DEditorHostPanePart::GetZoom | ( |  | ) | `[pure virtual]`

Returns the current zoom.

virtual void MCCOMAPI I3DEditorHostPanePart::InvalidateRender | ( |  | ) | `[pure virtual]`

Re-render next time RenderDraw is called

virtual void MCCOMAPI I3DEditorHostPanePart::LocalToRenderSpace | ( | const TMCPoint & | local,
|  | TVector2 & | render |
| ) |  |  | `[pure virtual]`

Converts from window coordinates (pixels) in pixels to screen coordinates (uv) that can be used by the camera.

Parameters:

  | local | The window coordinates (local) in pixels
  | render | The screen coordinates (render)

virtual boolean MCCOMAPI I3DEditorHostPanePart::NeedsReRender | ( |  | ) | `[pure virtual]`

Returns true if a new rendering is needed.

virtual void MCCOMAPI I3DEditorHostPanePart::PixelRay | ( | const TMCPoint & | pixelPos,
|  | TVector3 & | worldOrigin,
|  | TVector3 & | worldDirection |
| ) |  |  | `[pure virtual]`

Creates a ray from the current camera through the local (pixel) space.

Parameters:

  | pixelPos | The position in pixels.
  | worldOrigin | The origin of the ray in global coordinates.
  | worldDirection | The direction of the ray in global coordinates.

virtual void MCCOMAPI I3DEditorHostPanePart::RenderDraw | ( | IMCGraphicContext * | inContext,
|  | TMCRect * | inZone,
|  | ISceneDocument * | associatedSceneDoc |
| ) |  |  | `[pure virtual]`

Immediately renders and blits. Calls the extension's SelfRenderDraw for content.

Parameters:

  | inContext | The graphic context.
  | inZone | The zone that needs to be rendered.
  | associatedSceneDoc | The associated scene document (used to lock the pane part render see ISceneDocument::ShouldRenderPanePart())

virtual void MCCOMAPI I3DEditorHostPanePart::RenderToLocalSpace | ( | const TVector2 & | render,
|  | TMCPoint & | local |
| ) |  |  | `[pure virtual]`

Converts from screen coordinates (uv) in pixels to window coordinates (pixels) that can be used by the camera.

Parameters:

  | render | The screen coordinates (render)
  | local | The window coordinates (local) in pixels

virtual void MCCOMAPI I3DEditorHostPanePart::SetCurrentCamera | ( | I3DShCamera * | camera,
|  | boolean | resetPanAndZoom |
| ) |  |  | `[pure virtual]`

Sets the current camera for this view.

Parameters:

  | camera | A pointer to the camera.
  | resetPanAndZoom | True if the zoom and pan should be reset.

virtual void MCCOMAPI I3DEditorHostPanePart::SetImmediateMode | ( | boolean | on | ) | `[pure virtual]`

Turn on/off the immediate mode. The immediate mode is used for interactive manipulations by the user. When it is on, the rendering is blit directly to the screen without going through the back buffer.

Parameters:

  | on | True if the immediate mode should be on.

virtual void MCCOMAPI I3DEditorHostPanePart::SetPan | ( | TVector2 | pan | ) | `[pure virtual]`

Sets the current pan of the pane.

Parameters:

  | pan | The pan (2D translation).

virtual void MCCOMAPI I3DEditorHostPanePart::SetPaneIcon | ( | uint32 | inResourceID | ) | `[pure virtual]`

Sets the icon that is displayed at the bottom of the pane in a pane array. (For example the time in the storyboard room).

Parameters:

  | inResourceID | Resource ID of the icon. (should point to a UIImage resource)

virtual void MCCOMAPI I3DEditorHostPanePart::SetPaneText | ( | const TMCString & | text | ) | `[pure virtual]`

Sets the text that is displayed at the bottom of the pane in a pane array. (For example the time in the storyboard room).

Parameters:

  | text | The text.

virtual void MCCOMAPI I3DEditorHostPanePart::SetPopupCurrentItem | ( | int16 | index | ) | `[pure virtual]`

Sets the current item of the Pop up menu. Use this with I3DEditorHostPart::SetTopLeftPopup to handle the top-left popup menu

Parameters:

  | index | The index of the current item in the Popup menu.

virtual void MCCOMAPI I3DEditorHostPanePart::SetZoom | ( | double | zoom | ) | `[pure virtual]`

Sets the current zoom of the pane.

Parameters:

  | zoom | The zoom.

virtual void MCCOMAPI I3DEditorHostPanePart::ViewBox | ( | const TBBox3D & | bbox | ) | `[pure virtual]`

Moves the camera so that it sees the given bbox. Works only for perspective cameras. Posts an undoable action if the camera is not canonical.

Parameters:

  | bbox | the bounding box (in global coordinates)

virtual void MCCOMAPI I3DEditorHostPanePart::ZoomTo | ( | const TMCPoint & | localPos,
|  | boolean | zoomIn |
| ) |  |  | `[pure virtual]`

Zoom in or out

Parameters:

  | localPos | New center.
  | zoomIn | True if we zoom in, false if we zoom out

virtual void MCCOMAPI I3DEditorHostPanePart::ZoomTo | ( | const TMCRect & | localRect | ) | `[pure virtual]`

Zoom the pane to a given rectangle

Parameters:

  | localRect | The rectangle is given in local coordinates of the pane (pixels)

virtual void MCCOMAPI I3DEditorHostPanePart::ZoomToCenter | ( | double | zoom | ) | `[pure virtual]`

Zoom to the center of the view

Parameters:

  | zoom | The new zoom

virtual void MCCOMAPI I3DEditorHostPanePart::ZoomToRect | ( | const TMCRealRect & | rect | ) | `[pure virtual]`

Zoom the pane to a given rectange.

Parameters:

  | rect |

The documentation for this struct was generated from the following file:

- I3DEditorHostPart.h